﻿--[[
	InsanityTracker v15
		
	Copyright (c) 2010-2012, All rights reserved.

	by: Sará @ Festung der Stürme (EU-de)
		sarafdswow@gmail.com
		sarafds.de/addons

	You may:
		- use this AddOn, free of charge
		- modify this AddOn for your personal needs
		- use parts of code from this AddOn for your own non-commercial projects, as long as you give credit to the original author
		- use this license text for your own AddOns
	You may not:
		- redistribute (especially upload to AddOn sites) this AddOn or altered/modified versions of it without the author's permission
]]

local VERSION = (GetAddOnMetadata("InsanityTracker","Version"):gsub("%D+",""))
local STATUS = (GetAddOnMetadata("InsanityTracker","Version"):sub(5,5))

local it = { --main table
	["f"] = {}, --functions
	["l"] = { --localized..
		["i"] = {}, --item names
		["q"] = {}, --quest names
	},
	["name"] = "|cffff2200Insanity|cffffffffTracker|r",
	["name2"] = "|cffff2200Insanity|cffffffffTracker:|r",
	["version"] = " |cff22ff00["..STATUS..VERSION.."]|r",
	["author"] = " by Sará.Festung der Stürme-EU",
	["url1"] = "http://www.wowinterface.com/downloads/info16348.html",
	["url2"] = "http://wow.curse.com/downloads/wow-addons/details/insanitytracker.aspx",
	["translators"] = "Sará(deDE,enUS), wowhead&armory(frFR,esES,esMX,ruRU,koKR,zhCN,zhTW)",
}

local dropdown = CreateFrame("Frame","itd",UIParent,"UIDropDownMenuTemplate")
it.f.onclick = function(self,button)
	if button == "RightButton" then
		ToggleDropDownMenu(1,nil,dropdown,self,0,0)
	end
end

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("InsanityTracker",{type = "data source",icon = "Interface\\Icons\\Ability_Mage_BrainFreeze",iconCoords = { 0, 1, 0, 1 },text = "0 %",
--OnEnter = it.f.onenter,OnLeave = it.f.onleave,
OnClick = it.f.onclick})
local f = CreateFrame("GameTooltip","itf",nil,"GameTooltipTemplate")
f:RegisterEvent("UPDATE_FACTION")
f:RegisterEvent("QUEST_QUERY_COMPLETE")
f:RegisterEvent("CHAT_MSG_SYSTEM")
f:RegisterEvent("ADDON_LOADED")
local querylist = {
	["quest"] = {1036,4621,6681,6701,7905,7926,7937,8233,8234,8235,8236,9272},
	["item"] = {2309,2314,3240,3486,3825,3835,4363,4375,4582,5117,5134,5739,7945,8185,9313,11404,11407,11590,12644,15564,15994,16885,17124,19933},
} --quest and itemids to query localized names
local player,realm = UnitName("player"),GetRealmName()
local cplayer,crealm = player,realm
local starttime = GetTime()
local session = false
local loc = GetLocale()
local fac = {
	[1] = "bs",
	[2] = "dm",
	[3] = "rh",
	[4] = "bb",
	[5] = "el",
	[6] = "gz",
	[7] = "ra",
	[8] = "p",
	[9] = "abs",
} --for for looping

--default (english) locale
it.l.noloc = "|cffff0000 >> no supported locale found  -  please help translating << |r"
it.l.bs = "Bloodsail Buccaneers"
it.l.dm = "Darkmoon Faire"
it.l.rh = "Ravenholdt"
it.l.bb = "Booty Bay"
it.l.el = "Everlook"
it.l.gz = "Gadgetzan"
it.l.ra = "Ratchet"
it.l.herbalism = "Herbalism"
it.l.cooking = "Cooking"
it.l.engineering = "Engineering"
it.l.sw = "Steamwheedle Cartel"
it.l.loaded = "loaded"
it.l.show = "Show completed Factions in Tooltip"
it.l.showcurrent = "Show only current step"
it.l.repmod = "+10% Reputation-Buff"
it.l.set = "Set Faction as completed"
it.l.options = "Options"
it.l.optionsdone = it.name2.."Options were reset"
it.l.playerinfo = "Player Information"
it.l.playerinfodone = it.name2.."Player Information was reset"
it.l.repvaluesdone = it.name2.."Reputation Values were reset"
it.l.quests = "Quests"
it.l.questsdone = it.name2.."Quests were reset"
it.l.sessiondone = it.name2.."Session progress was reset"
it.l.about = "About"
it.l.choose = "Choose Character"
it.l.delete = "Delete Character"
it.l.lockbox = "Track Lockboxes"
it.l.session = "Show Session progress"
it.l.resetsession = "Reset Session"
it.l.eta = "Show estimated time to go"
it.l.repperh = "Show Reputation per hour"
it.l.perfaction = "per Faction"
it.l.togopre = ""
it.l.togo = " to go"
it.l.lockboxcounter = "Reset Lockbox counter"
it.l.abouttext1 = "You will need a LDB Display Addon to use this Addon"
it.l.abouttext2 = "For more Information and Updates, visit:"
it.l.abouttrans = "Translators: "..it.translators
it.l.guards = "Guards"
it.l.pirates = "Pirates"
it.l.syndicates = "Syndicate Members"
it.l.gdmc = "Greater Darkmoon Faire Decks"
it.l.ldmc = "Small Darkmoon Faire Decks"
it.l.dmcturnin = "turn-in-Quests"
it.l.session = "This Session"
it.l.A = "(A)" --Alliance
it.l.H = "(H)" --Horde
it.l.insane = "|cffff0000  -  YOU ARE |cffffff00[Insane in the Membrane]|cffff0000 !  -  |r"

--overwrite with client locale
if loc == "deDE" then
	it.l.noloc = " "
	it.l.bs = "Blutsegelbukaniere"
	it.l.dm = "Dunkelmond-Jahrmarkt"
	it.l.rh = "Rabenholdt"
	it.l.bb = "Beutebucht"
	it.l.el = "Ewige Warte"
	it.l.ra = "Ratschet"
	it.l.herbalism = "Kräuterkunde"
	it.l.cooking = "Kochkunst"
	it.l.eng = "Ingenieurskunst"
	it.l.sw = "Dampfdruckkartell"
	it.l.loaded = "geladen"
	it.l.show = "Zeige fertige Fraktionen im Tooltip"
	it.l.showcurrent = "Zeige nur aktuellen Schritt"
	it.l.repmod = "+10% Ruf-Buff"
	it.l.set = "Setze Fraktion auf den benötigten Wert"
	it.l.options = "Optionen"
	it.l.optionsdone = it.name2.."Optionen wurden zurückgesetzt"
	it.l.playerinfo = "Spielerinformationen"
	it.l.playerinfodone = it.name2.."Spielerinformationen wurden zurückgesetzt"
	it.l.repvaluesdone = it.name2.."Gespeicherte Ruf-Werte wurden zurückgesetzt"
	it.l.quests = "Quests"
	it.l.questsdone = it.name2.."Quests wurden zurückgesetzt"
	it.l.sessiondone = it.name2.."Sitzung wurde zurückgesetzt"
	it.l.about = "Über"
	it.l.choose = "Wähle Character"
	it.l.delete = "Lösche Character"
	it.l.lockbox = "Zähle Plunderkisten"
	it.l.session = "Zeige Sitzungsfortschritt"
	it.l.resetsession = "Setze Sitzungsfortschritt zurück"
	it.l.eta = "Zeige voraussichtlich benötigte Zeit"
	it.l.repperh = "Zeige Ruf pro Stunde"
	it.l.perfaction = "pro Fraktion"
	it.l.togopre = "noch "
	it.l.togo = ""
	it.l.lockboxcounter = "Plunderkisten-Zähler zurücksetzen"
	it.l.abouttext1 = "Um dieses Addon zu nutzen wird ein LDB-Anzeige Addon benötigt"
	it.l.abouttext2 = "Für mehr Informationen und Updates, besucht:"
	it.l.abouttrans = " Übersetzer: "..it.translators
	it.l.guards = "Wachen"
	it.l.pirates = "Piraten"
	it.l.syndicates = "Syndikatsmitglieder"
	it.l.gdmc = "große Dunkelmond-Kartensets"
	it.l.ldmc = "kleine Dunkelmond-Kartensets"
	it.l.dmcturnin = "Abgabe-Quests"
	it.l.session = "Diese Sitzung"
	it.l.insane = "|cffff0000  -  DU BIST |cffffff00[Am Rande des Wahnsinns]|cffff0000 !  -  |r"
elseif loc == "frFR" then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "La Voile sanglante"
	it.l.dm = "Foire de Sombrelune"
	it.l.bb = "Baie-du-Butin"
	it.l.el = "Long-guet"
	it.l.ra = "Cabestan"
	it.l.herbalism = "Herboristerie"
	it.l.cooking = "Cuisine"
	it.l.engineering = "Ingénierie"
	it.l.sw = "Cartel Gentepression"
elseif (loc == "esES") or (loc == "esMX") then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "Bucaneros Velasangre"
	it.l.dm = "Feria de la Luna Negra"
	it.l.bb = "Bahía del Botín"
	it.l.el = "Vista Eterna"
	it.l.ra = "Trinquete"
	it.l.herbalism = "Herboristería"
	it.l.cooking = "Cocina"
	it.l.engineering = "Ingeniería"
	it.l.sw = "Cártel Bonvapor"
elseif loc == "ruRU" then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "Пираты Кровавого Паруса"
	it.l.dm = "Ярмарка Новолуния"
	it.l.rh = "Черный Ворон"
	it.l.bb = "Пиратская Бухта"
	it.l.el = "Круговзор"
	it.l.gz = "Прибамбасск"
	it.l.ra = "Кабестан"
	it.l.herbalism = "Травничество"
	it.l.cooking = "кулинария"
	it.l.engineering = "Инженерное дело"
	it.l.sw = "Картель Хитрая Шестеренка"
	it.l.H = "(O)" --Horde
elseif loc == "koKR" then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "붉은해적단"
	it.l.dm = "다크문 유랑단"
	it.l.rh = "라벤홀트"
	it.l.bb = "무법항"
	it.l.el = "눈망루 마을"
	it.l.gz = "가젯잔"
	it.l.ra = "톱니항"
	it.l.herbalism = "약초채집"
	it.l.cooking = "요리"
	it.l.engineering = "기계공학"
elseif loc == "zhCN" then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "血帆海盗"
	it.l.dm = "暗月马戏团"
	it.l.rh = "拉文霍德"
	it.l.bb = "藏宝海湾"
	it.l.el = "永望镇"
	it.l.gz = "加基森"
	it.l.ra = "棘齿城"
	it.l.herbalism = "草药学"
	it.l.cooking = "烹饪"
	it.l.engineering = "工程学"
elseif loc == "zhTW" then
	it.l.noloc = "|cffff0000 >> locale supported but not yet fully translated  -  please help translating << |r"
	it.l.bs = "血帆海盜"
	it.l.dm = "暗月馬戲團"
	it.l.rh = "拉文霍德"
	it.l.bb = "藏寶海灣"
	it.l.el = "永望鎮"
	it.l.gz = "加基森"
	it.l.ra = "棘齒城"
	it.l.herbalism = "草藥學"
	it.l.cooking = "烹飪"
	it.l.engineering = "工程學"
elseif loc == "enGB" or "enUS" then
	it.l.noloc = " "
end

--Functions
it.f.dropdown = function(self,level)
	level = level or 1
	local info = UIDropDownMenu_CreateInfo()
	if level == 1 then
		info = UIDropDownMenu_CreateInfo()
		info.text = it.name..it.version..it.author
		info.isTitle = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		info = UIDropDownMenu_CreateInfo()
		info.text = it.l.choose
		info.notCheckable = true
		info.hasArrow = true
		info.value = "choose"
		UIDropDownMenu_AddButton(info, level)
		info = UIDropDownMenu_CreateInfo()
		info.text = it.l.resetsession
		info.func = it.f.reset
		info.notCheckable = true
		info.arg1 = "session"
		info.arg2 = true
		UIDropDownMenu_AddButton(info,level)
		info = UIDropDownMenu_CreateInfo()
		info.text = it.l.options
		info.notCheckable = true
		info.hasArrow = true
		info.value = "options"
		info.keepShownOnClick = true
		UIDropDownMenu_AddButton(info, level)
		info = UIDropDownMenu_CreateInfo()
		info.text = it.l.about
		info.notCheckable = true
		info.func = it.f.about
		UIDropDownMenu_AddButton(info, level)
	end
	if level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "choose" then
			local chars,name=0,{}
			for n,_ in pairs(insanitytrackersv[realm]) do 
				if n~="lockboxcounter" then chars=chars+1 name[chars]=n end
			end
			for i=1,chars do
				info = UIDropDownMenu_CreateInfo()
				info.text = name[i]
				info.notCheckable = true
				info.func = it.f.choose
				info.arg1 = name[i]
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "options" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.show
			info.checked = true and insanitytrackersv.options.showcomplete==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "showcomplete"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.showcurrent
			info.checked = true and insanitytrackersv.options.showcurrent==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "showcurrent"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.repmod
			info.checked = true and insanitytrackersv.options.repmod==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "repmod"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.lockbox
			info.hasArrow = true
			info.value = "boxes"
			info.checked = true and insanitytrackersv.options.lockboxes==1
			info.isNotRadio = true
			info.func = it.f.lockbox
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.session
			info.hasArrow = true
			info.value = "session"
			info.checked = true and insanitytrackersv.options.session==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "session"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.repperh
			info.hasArrow = true
			info.value = "repperh"
			info.checked = true and insanitytrackersv.options.repperh==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "repperh"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.eta
			info.hasArrow = true
			info.value = "eta"
			info.checked = true and insanitytrackersv.options.eta==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "eta"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = RESET
			info.notCheckable = true
			info.hasArrow = true
			info.value = "reset"
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.set
			info.notCheckable = true
			info.hasArrow = true
			info.value = "set"
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.delete
			info.notCheckable = true
			info.hasArrow = true
			info.value = "delete"
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = "debug mode"
			info.hasArrow = true
			info.value = "debug"
			info.checked = true and insanitytrackersv.debug==1
			info.isNotRadio = true
			info.func = it.f.debug
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
		end
	end
	if level == 3 then
		if UIDROPDOWNMENU_MENU_VALUE == "session" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.perfaction
			info.checked = true and insanitytrackersv.options.sessionfaction==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "sessionfaction"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "eta" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.perfaction
			info.checked = true and insanitytrackersv.options.etafaction==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "etafaction"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "repperh" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.perfaction
			info.checked = true and insanitytrackersv.options.repperhfaction==1
			info.isNotRadio = true
			info.func = it.f.toggleoption
			info.arg1 = "repperhfaction"
			info.keepShownOnClick = true
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "delete" then
			local chars,name=0,{}
			for n,_ in pairs(insanitytrackersv[realm]) do 
				if n~="lockboxcounter" then chars=chars+1 name[chars]=n end
			end
			for i=1,chars do
				if name[i]~=player then
					info = UIDropDownMenu_CreateInfo()
					info.text = name[i]
					info.notCheckable = true
					info.func = it.f.delete
					info.arg1 = name[i]
					UIDropDownMenu_AddButton(info, level)
				end
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "set" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.sw
			info.notCheckable = true
			info.func = it.f.sw
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.bs
			info.notCheckable = true
			info.func = it.f.bs
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "debug" then
			info = UIDropDownMenu_CreateInfo()
			info.text = "re-query itemnames"
			info.notCheckable = true
			info.func = it.f.query
			info.arg1 = "item"
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = "re-query questnames"
			info.notCheckable = true
			info.func = it.f.query
			info.arg1 = "quest"
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "boxes" then
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.lockboxcounter
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "lockboxcounter"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "reset" then
			info = UIDropDownMenu_CreateInfo()
			info.text = ALL
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "all"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.quests
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "quests"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)

			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.playerinfo
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "playerinfo"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = REPUTATION
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "rep"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)
			info = UIDropDownMenu_CreateInfo()
			info.text = it.l.options
			info.notCheckable = true
			info.func = it.f.reset
			info.arg1 = "options"
			info.arg2 = true
			UIDropDownMenu_AddButton(info, level)
		end
	end
end

UIDropDownMenu_Initialize(dropdown,it.f.dropdown,"MENU")

it.f.update = function()
	if insanitytrackersv.options.swasone == 1 then
		insanitytrackersv[realm][player]["abs"] = (insanitytrackersv[realm][player]["bs"] + insanitytrackersv[realm][player]["dm"] + insanitytrackersv[realm][player]["rh"] + math.min(insanitytrackersv[realm][player]["bb"], insanitytrackersv[realm][player]["el"], insanitytrackersv[realm][player]["gz"], insanitytrackersv[realm][player]["ra"]))
		insanitytrackersv[realm][player]["p"] = (insanitytrackersv[realm][player]["abs"] / 1350)
	else
		insanitytrackersv[realm][player]["abs"] = (insanitytrackersv[realm][player]["bs"] + insanitytrackersv[realm][player]["dm"] + insanitytrackersv[realm][player]["rh"] + insanitytrackersv[realm][player]["bb"] + insanitytrackersv[realm][player]["el"] + insanitytrackersv[realm][player]["gz"] + insanitytrackersv[realm][player]["ra"])
		insanitytrackersv[realm][player]["p"] = (insanitytrackersv[realm][player]["abs"] / 2610)
	end
	dataobj.text = insanitytrackersv[crealm][cplayer]["p"]<100 and string.format("%."..insanitytrackersv.options.fpnr.."f%%",insanitytrackersv[crealm][cplayer]["p"]) or ""
	if player~=cplayer then dataobj.text = cplayer..": "..dataobj.text end
end

it.f.delete = function(self,arg1)
	if arg1==cplayer then
		cplayer=player
		it.f.update()
	end
	insanitytrackersv[realm][arg1]=nil
end

it.f.choose = function(self,arg1)
	cplayer=arg1
	it.f.update()
end

it.f.toggleoption = function(self,arg1)
	insanitytrackersv.options[arg1] = insanitytrackersv.options[arg1] == 0 and 1 or 0
end

it.f.debug = function()
	insanitytrackersv.debug = insanitytrackersv.debug == 0 and 1 or 0
end

it.f.timeleft = function(sec)
	if sec<0 then return "∞" end
	local D = floor(sec/86400)
	local H = format("%02.f",floor((sec/3600)-(D*24)))
	local M = format("%02.f",floor((sec/60)-(H*60)-(D*1440)))
	local S = format("%02.f",floor(sec-(H*3600)-(M*60)-(D*86400)))
	return D~=0 and D.."d "..H..":"..M..":"..S.."h" or H~="00" and H..":"..M..":"..S.."h" or M..":"..S.."m"
end

it.f.lockbox = function()
	if insanitytrackersv.options.lockboxes == 0 then
		insanitytrackersv.options.lockboxes = 1
		f:RegisterEvent("CHAT_MSG_LOOT")
	else
		insanitytrackersv.options.lockboxes = 0
		f:UnregisterEvent("CHAT_MSG_LOOT")
	end
end

it.f.about = function()
	print(it.name..it.version..it.author)
	print(it.l.abouttrans)
	print(it.l.abouttext1)
	print(it.l.abouttext2)
	print(it.url1)
	print(it.url2)
end

it.f.sw = function()
	for i=4,7 do
		insanitytrackersv[realm][player][fac[i]] = 42000
	end
	it.f.update()
end

it.f.bs = function()
	insanitytrackersv[realm][player]["bs"] = 9000
	it.f.update()
end

it.f.reset = function(self,arg,s)
	if arg == "all" then
		insanitytrackersv = {
			["version"] = VERSION,
			["debug"] = false,
			["options"] = {},
			[realm] = {
				[player] = {}
			}
		}
		it.f.reset(self,"options")
		it.f.reset(self,"quests")
		it.f.reset(self,"playerinfo")
		it.f.reset(self,"rep")
		it.f.reset(self,"session")
		it.f.reset(self,"lockboxcounter")
	elseif arg == "options" then
		insanitytrackersv.options = {
			["showcomplete"] = 1,
			["showcurrent"] = 0,
			["swasone"] = 1,
			["fpnr"] = 1,
			["lockboxes"] = 1,
			["session"] = 1,
			["sessionfaction"] = 0,
			["eta"] = 1,
			["etafaction"] = 0,
			["repperh"] = 0,
			["repperhfaction"] = 0,
			["repmod"] = 0,
		}
		if s then print(it.l.optionsdone)end
	elseif arg == "quests" then
		insanitytrackersv[realm][player]["quests"] = {}
		for i=1,#querylist.quest do
			if quests[querylist.quest[i]] then
				insanitytrackersv[realm][player]["quests"][querylist.quest[i]] = IsQuestFlaggedComplete(querylist.quest[i])
			end
		end
		if s then print(it.l.questsdone)end
	elseif arg == "playerinfo" then
		insanitytrackersv[realm][player]["class"] = select(2,UnitClass("player"))
		insanitytrackersv[realm][player]["level"] = UnitLevel("player")
		insanitytrackersv[realm][player]["humanity"] = select(2,UnitRace("player")) == "Human" and 1.1 or 1
		insanitytrackersv[realm][player]["herbalism"] = 0
		insanitytrackersv[realm][player]["cooking"] = 0
		insanitytrackersv[realm][player]["engineering"] = 0
		if IsInGuild() then
			if GetGuildLevel()>11 then
				insanitytrackersv[realm][player]["glevel"] = 0.1
			elseif GetGuildLevel()>3 then
				insanitytrackersv[realm][player]["glevel"] = 0.05
			else
				insanitytrackersv[realm][player]["glevel"] = 0
			end
		else
			insanitytrackersv[realm][player]["glevel"] = 0
		end
	
-- from framexml/spellbookframe	
--		 local name, texture, rank, maxRank, numSpells, spelloffset, skillLine = GetProfessionInfo(index);
-- prof1, prof2, arch, fish, cook, firstAid = GetProfessions()
-- gets the indices
		
		for i = 5,9 do
			local n,_,r = GetProfessionInfo(i)
			if n == it.l.herbalism then
				insanitytrackersv[realm][player]["herbalism"] = r
			elseif n == it.l.cooking then
				insanitytrackersv[realm][player]["cooking"] = r
			elseif n == it.l.eng then
				insanitytrackersv[realm][player]["engineering"] = r
			end
		end
		if s then print(it.l.playerinfodone)end
	elseif arg == "rep" then
		for i=1,9 do
			insanitytrackersv[realm][player][fac[i]] = 0
		end
		it.f.run()
		if s then print(it.l.repvaluesdone)end
	elseif arg == "session" then
		session = {}
		for i=1,9 do
			session[fac[i]] = insanitytrackersv[realm][player][fac[i]]
		end
		starttime = GetTime()
		if s then print(it.l.sessiondone)end
	elseif arg == "lockboxcounter" then
		insanitytrackersv[realm]["lockboxcounter"] = 0
	end
end

it.f.query = function(self,type)
	for id = 1, #querylist[type] do
		i=0
		repeat
			local name = it.f.getname(type,querylist[type][id])
			it.l[string.sub(type,1,1)][querylist[type][id]] = name and "|cffffff00["..name.."]|r" or "|cffffff00["..type..":"..querylist[type][id].."]|r"
			i=i+1
		until (it.l[string.sub(type,1,1)][querylist[type][id]] ~= "|cffffff00["..type..":"..querylist[type][id].."]|r") or (it.l[string.sub(type,1,1)][querylist[type][id]] ~= "|cffffff00["..RETRIEVING_ITEM_INFO.."]|r") or i>3
	end
end

it.f.getname = function(type,id)
	f:SetHyperlink(type..":"..id)
	return it.l._
end

it.f.status = function(max,min,fac)
	if fac >= max then 
		return "|cff00ff00"..DONE.."!|r"
	else
		return it.f.statuscolor(0,fac,max,min,max-fac.." "..REPUTATION)
	end
end
	
it.f.statuscolor = function(off,fac,max,min,str)
	if fac >= off then
		col = string.format("%02x",(max-fac)/((max-off)/255)).."ff00"
	end
	if fac <= off then
		col = "ff"..string.format("%02x",(min+fac)/((min+off)/255)).."00"
	end
	return "|cff"..col..str.."|r"
end

it.f.run = function()
	for i = 1,100 do
		local n,_,_,_,_,e = GetFactionInfo(i)
		if not n then break end
		for f=1,7 do
			local limit = f==1 and 9000 or 42000
			if n == it.l[fac[f]] then
				if e >= limit then
					insanitytrackersv[realm][player][fac[f]] = limit
				end
				if insanitytrackersv[realm][player][fac[f]] ~= limit then
					insanitytrackersv[realm][player][fac[f]] = e
					if IsFactionInactive(i) then
						SetFactionActive(i)
					end
				end
			end
		end
	end
	it.f.update()
end




--onload
f:SetScript("OnTooltipSetQuest", function (self)
	it.l._=itfTextLeft1:GetText()
if insanitytrackersv.debug == 1 then print(itfTextLeft1:GetText())end
end)

f:SetScript("OnTooltipSetItem", function (self)
	it.l._=itfTextLeft1:GetText()
if insanitytrackersv.debug == 1 then print(itfTextLeft1:GetText())end
end)

f:SetScript("OnEvent", function(self, event,arg)
	if event == "ADDON_LOADED" and arg=="InsanityTracker" then
		if not insanitytrackersv then
			it.f.reset(self,"all")
		end
		if tonumber(insanitytrackersv.version)<11 then
			it.f.reset(self,"quests")
			insanitytrackersv.options.showcurrent = 0
			insanitytrackersv.version="11"
		end
		if tonumber(insanitytrackersv.version)<13 then
			insanitytrackersv.options.repmod = 0
		end
		if tonumber(insanitytrackersv.version)<tonumber(VERSION) then
			insanitytrackersv.version = VERSION
		end
		if not insanitytrackersv[realm] then
			insanitytrackersv[realm] = {}
			insanitytrackersv[realm]["lockboxcounter"] = 0
			if insanitytrackersv.debug==1 then print(realm.." didn't exist: created")end
		end
		if not insanitytrackersv[realm][player] then
			insanitytrackersv[realm][player] = {}
			if insanitytrackersv.debug==1 then print(player.." didn't exist: created")end
			it.f.reset(self,"quests")
			it.f.reset(self,"playerinfo")
			it.f.reset(self,"rep")
			it.f.reset(self,"session")
		end
		if not insanitytrackersv[realm][player]["glevel"] then
			it.f.reset(self,"playerinfo")
		end
		if not session then
			it.f.reset(self,"session")
		end
		if insanitytrackersv.options.lockboxes == 1 then
			f:RegisterEvent("CHAT_MSG_LOOT")
			insanitytrackersv[realm]["lockboxcounter"] = insanitytrackersv[realm]["lockboxcounter"] or 0
		end
	end
	if event == "UPDATE_FACTION" then
		if insanitytrackersv.debug==1 then print("UPDATE_FACTION fired")end
		it.f.run()
	end
	if event == "CHAT_MSG_SYSTEM" then
		if string.find(arg,string.gsub(ERR_QUEST_COMPLETE_S, "(%%s)", "")) then
			it.f.reset(self,"quests")
			it.f.reset(self,"playerinfo")
		end
	end
	if event == "CHAT_MSG_LOOT" then
		if string.find(arg,it.f.getname("item",16885)) then
			insanitytrackersv[realm]["lockboxcounter"] = insanitytrackersv[realm]["lockboxcounter"] + 1
		end
	end
end)

--ldb tooltip
function dataobj:OnTooltipShow()
	self:AddLine(it.name2..cplayer)
	self:AddLine(it.l.noloc)
	if not it.l.q[querylist.quest[1]] then
		it.f.query(self,"quest")
	end
	if not it.l.i[querylist.item[1]] then
		it.f.query(self,"item")
	end
	local gz,el,rh,ra,c,f,bs,bb,dm,lvl,h,q = insanitytrackersv[crealm][cplayer]["gz"],insanitytrackersv[crealm][cplayer]["el"],insanitytrackersv[crealm][cplayer]["rh"],insanitytrackersv[crealm][cplayer]["ra"],insanitytrackersv[crealm][cplayer]["class"],insanitytrackersv[crealm][cplayer]["faction"],insanitytrackersv[crealm][cplayer]["bs"],insanitytrackersv[crealm][cplayer]["bb"],insanitytrackersv[crealm][cplayer]["dm"],insanitytrackersv[crealm][cplayer]["level"],insanitytrackersv[crealm][cplayer]["humanity"],insanitytrackersv[crealm][cplayer]["quests"]
	if insanitytrackersv.options.repmod==1 then h=h+0.1 end
	h=h+insanitytrackersv[realm][player]["glevel"]
--Bloodsail
	if (bs < 9000) or ((bs >= 9000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine(it.l.bs..":", it.f.status(9000,42000,bs))
		if bs < 9000 then
			self:AddDoubleLine("   "..it.l.bb.."-"..it.l.guards..": ", it.f.statuscolor(0,bs,9000,42000,math.ceil((9000-bs)/(25*h))))
		end
		if (bs > 0) and (bb < -6000) and (lvl >= 49) and not q[9272] then
			self:AddDoubleLine("   "..it.l.q[9272], "+"..10*h.." "..REPUTATION)
		end
		if (bs >= 3000) and (bb < -6000) and (lvl >= 55) and not q[1036] then
			self:AddDoubleLine("   "..it.l.q[1036], "+"..25*h.." "..REPUTATION)
		end
		if (bs >= 3000) and (bb < -6000) and (lvl >= 55) and q[1036] and not q[4621] then
			self:AddDoubleLine("   "..it.l.q[4621], "+"..500*h.." "..REPUTATION)
		end
		if bs ~= session.bs then
			if insanitytrackersv.options.sessionfaction == 1 then
				self:AddDoubleLine(it.l.session..": ", bs-session["bs"]..REPUTATION)
			end
			if insanitytrackersv.options.repperhfaction == 1 then
				self:AddDoubleLine(" ", floor(((bs-session["bs"])*3600)/(GetTime()-starttime)).." "..REPUTATION.."/h")
			end
			if insanitytrackersv.options.etafaction == 1 and bs < 9000 then
				self:AddDoubleLine(" ", it.l.togopre..it.f.timeleft((9000-bs)/((bs-session["bs"])/(GetTime()-starttime)))..it.l.togo)
			end
		end
		self:AddLine(" ")
	end
--darkmoon
	if (dm < 42000) or ((dm >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine(it.l.dm..":", it.f.status(42000,42000,dm))
		if (lvl >= 6) and (dm < 42000) then
			if not q[7905] then
				self:AddDoubleLine("   "..it.l.q[7905]..it.l.A, "+"..75*h.." "..REPUTATION)
			end
			if not q[7926] then
				self:AddDoubleLine("   "..it.l.q[7926]..it.l.H, "+"..75*h.." "..REPUTATION)
			end
		end
		if (lvl >= 10) and (dm < 42000) then
			self:AddDoubleLine("   "..it.l.q[7937], "+"..75*h.." "..REPUTATION)
		end
		if dm < 5000 then
			if dm < 425 then
				self:AddDoubleLine("   1/6: "..it.l.i[2309], it.f.statuscolor(0,dm,425,42000,"x"..math.ceil((425-dm)/(250*h))*3))
				self:AddDoubleLine("   1/6: "..it.l.i[3240], it.f.statuscolor(0,dm,425,42000,"x"..math.ceil((425-dm)/(250*h))*10))
				self:AddDoubleLine("   1/6: "..it.l.i[4363], it.f.statuscolor(0,dm,425,42000,"x"..math.ceil((425-dm)/(250*h))*5))
				self:AddDoubleLine("   1/6: "..it.l.i[5134], it.f.statuscolor(0,dm,425,42000,"x"..math.ceil((425-dm)/(250*h))*5))
			end
if (insanitytrackersv.options.showcurrent==1 and dm>424) or insanitytrackersv.options.showcurrent==0 then
			if (dm < 1075) and (lvl >= 10) then
				self:AddDoubleLine("   2/6: "..it.l.i[2314], it.f.statuscolor(425,dm,1075,42000,"x"..math.ceil((1075-dm)/(250*h))*3))
				self:AddDoubleLine("   2/6: "..it.l.i[3486], it.f.statuscolor(425,dm,1075,42000,"x"..math.ceil((1075-dm)/(250*h))*7))
				self:AddDoubleLine("   2/6: "..it.l.i[4375], it.f.statuscolor(425,dm,1075,42000,"x"..math.ceil((1075-dm)/(250*h))*7))
				self:AddDoubleLine("   2/6: "..it.l.i[11407], it.f.statuscolor(425,dm,1075,42000,"x"..math.ceil((1075-dm)/(250*h))*5))
			end
end
if (insanitytrackersv.options.showcurrent==1 and dm>1074) or insanitytrackersv.options.showcurrent==0 then
			if (dm < 1625) and (lvl >= 20) then
				self:AddDoubleLine("   3/6: "..it.l.i[5739], it.f.statuscolor(1075,dm,1625,42000,"x"..math.ceil((1625-dm)/(250*h))*3))
				self:AddDoubleLine("   3/6: "..it.l.i[3835], it.f.statuscolor(1075,dm,1625,42000,"x"..math.ceil((1625-dm)/(250*h))*3))
				self:AddDoubleLine("   3/6: "..it.l.i[9313], it.f.statuscolor(1075,dm,1625,42000,"x"..math.ceil((1625-dm)/(250*h))*36))
				self:AddDoubleLine("   3/6: "..it.l.i[4582], it.f.statuscolor(1075,dm,1625,42000,"x"..math.ceil((1625-dm)/(250*h))*5))
			end
end
if (insanitytrackersv.options.showcurrent==1 and dm>1624) or insanitytrackersv.options.showcurrent==0 then
			if (dm < 2500) and (lvl >= 30) then
				self:AddDoubleLine("   4/6: "..it.l.i[8185], it.f.statuscolor(1625,dm,2500,42000,"x"..math.ceil((2500-dm)/(250*h))))
				self:AddDoubleLine("   4/6: "..it.l.i[7945], it.f.statuscolor(1625,dm,2500,42000,"x"..math.ceil((2500-dm)/(250*h))))
				self:AddDoubleLine("   4/6: "..it.l.i[11590], it.f.statuscolor(1625,dm,2500,42000,"x"..math.ceil((2500-dm)/(250*h))*6))
				self:AddDoubleLine("   4/6: "..it.l.i[5117], it.f.statuscolor(1625,dm,2500,42000,"x"..math.ceil((2500-dm)/(250*h))*5))
			end
end
if (insanitytrackersv.options.showcurrent==1 and dm>2499) or insanitytrackersv.options.showcurrent==0 then
			if (lvl >= 40) then
				self:AddDoubleLine("   5/6: "..it.l.i[15564], it.f.statuscolor(2500,dm,2500,42000,"x"..math.ceil((5000-dm)/(250*h))*8))
				self:AddDoubleLine("   5/6: "..it.l.i[12644], it.f.statuscolor(2500,dm,2500,42000,"x"..math.ceil((5000-dm)/(250*h))*8))
				self:AddDoubleLine("   5/6: "..it.l.i[15994], it.f.statuscolor(2500,dm,2500,42000,"x"..math.ceil((5000-dm)/(250*h))*6))
				self:AddDoubleLine("   5/6: "..it.l.i[11404], it.f.statuscolor(2500,dm,2500,42000,"x"..math.ceil((5000-dm)/(250*h))*10))
				self:AddDoubleLine("   5/6: "..it.l.i[19933], it.f.statuscolor(2500,dm,2500,42000,"x"..math.ceil((5000-dm)/(250*h))*10))
			end
end
		end
if (insanitytrackersv.options.showcurrent==1 and dm>4999) or insanitytrackersv.options.showcurrent==0 then
		if dm < 42000 then
			self:AddDoubleLine("   6/6: "..it.l.gdmc, it.f.statuscolor(5000,dm,42000,42000,"x"..math.ceil((42000-dm)/(350*h))))
		end
		if (dm < 42000) and (lvl >=10) then
			self:AddDoubleLine("   6/6: "..it.l.ldmc, it.f.statuscolor(5000,dm,42000,42000,"x"..math.ceil((42000-dm)/(25*h))))
		end
end
		if dm ~= session.dm then
			if insanitytrackersv.options.sessionfaction == 1 then
				self:AddDoubleLine(it.l.session..": ", dm-session["dm"]..REPUTATION)
			end
			if insanitytrackersv.options.repperhfaction == 1 then
				self:AddDoubleLine(" ", floor(((dm-session["dm"])*3600)/(GetTime()-starttime)).." "..REPUTATION.."/h")
			end
			if insanitytrackersv.options.etafaction == 1 and dm < 42000 then
				self:AddDoubleLine(" ", it.l.togopre..it.f.timeleft((42000-dm)/((dm-session["dm"])/(GetTime()-starttime)))..it.l.togo)
			end
		end
		self:AddLine(" ")
	end
--ravenholdt
	if (rh < 42000) or ((rh >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine(it.l.rh..":", it.f.status(42000,42000,rh))
		if (rh < 3000) and (lvl >=24) and (c == "ROGUE") and q[6681] then
			self:AddDoubleLine("   0/2: "..it.l.q[6701], it.l.i[17124]..it.f.statuscolor(0,rh,3000,42000," x"..math.ceil((3000-rh)/(250*h))))
		end
		if rh < 20999 then
			if (insanitytrackersv.options.showcurrent==1 and c=="ROGUE" and q[6681] and rh>2999 and lvl>=24) or (insanitytrackersv.options.showcurrent==1 and c~="ROGUE") or insanitytrackersv.options.showcurrent==0 then
				self:AddDoubleLine("   1/2: "..it.l.syndicates..": ", it.f.statuscolor(0,rh,20999,42000,math.ceil((20999-rh)/(5*h))))
			end
		end
		if (rh < 42000) and (lvl >=50) then
			if (insanitytrackersv.options.showcurrent==1 and rh>20998) or insanitytrackersv.options.showcurrent==0 then
				if insanitytrackersv.options.lockboxes == 1 then
					self:AddDoubleLine("   2/2: "..it.l.i[16885], it.f.statuscolor(20999,(rh + (insanitytrackersv[realm]["lockboxcounter"]*15*h)),42000,42000,insanitytrackersv[realm]["lockboxcounter"].." / "..(math.ceil((42000-rh)/(75*h))*5)))
				else
					self:AddDoubleLine("   2/2: "..it.l.i[16885], it.f.statuscolor(20999,rh,42000,42000," x"..(math.ceil((42000-rh)/(75*h))*5)))
				end
			end
		end
		if c == "ROGUE" then
			if lvl >= 24 and not q[6681] then
				self:AddDoubleLine("   "..it.l.q[6681], "+"..250*h.." "..REPUTATION)
			end
			if lvl >= 50 then
				if not q[8233] then
					self:AddDoubleLine("   "..it.l.q[8233], "+"..10*h.." "..REPUTATION)
				end
				if q[8233] and not q[8234] then
					self:AddDoubleLine("   "..it.l.q[8234], "+"..250*h.." "..REPUTATION)
				end
				if q[8234] and not q[8235] then
					self:AddDoubleLine("   "..it.l.q[8235], "+"..250*h.." "..REPUTATION)
				end
				if q[8235] and not q[8236] then
					self:AddDoubleLine("   "..it.l.q[8236], "+"..250*h.." "..REPUTATION)
				end
			end
		end
		if rh ~= session.rh then
			if insanitytrackersv.options.sessionfaction == 1 then
				self:AddDoubleLine(it.l.session..": ", rh-session["rh"]..REPUTATION)
			end
			if insanitytrackersv.options.repperhfaction == 1 then
				self:AddDoubleLine(" ", floor(((rh-session["rh"])*3600)/(GetTime()-starttime)).." "..REPUTATION.."/h")
			end
			if insanitytrackersv.options.etafaction == 1 and rh < 42000 then
				self:AddDoubleLine(" ", it.l.togopre..it.f.timeleft((42000-rh)/((rh-session["rh"])/(GetTime()-starttime)))..it.l.togo)
			end
		end
		self:AddLine(" ")
	end
--steamwheedle
	if (math.min(bb, el, gz, ra) < 42000) or ((math.min(bb, el, gz, ra) >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine(it.l.sw..":", it.f.status(168000,168000,(bb+el+gz+ra)))
		if math.min(bb, el, gz, ra) < 42000 then
			self:AddDoubleLine("   "..it.l.pirates..": ", it.f.statuscolor(0,math.min(bb, el, gz, ra),42000,42000,math.ceil((42000-math.min(bb, el, gz, ra))/(2.5*h))))
		end
	end

	if (bb < 42000) or ((bb >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine("  "..it.l.bb..":", it.f.status(42000,42000,bb))
--	if bb < 0 then
--		self:AddDoubleLine("   |cffff0000(-"..it.l.bs..")|r:", it.f.statuscolor(0,bb,42000,42000,it.l.silk.."-"..it.l.dmcturnin..": "..math.ceil((42000-bb)/(500*h)).." ("..math.ceil((42000-bb)/(500*h))
--	end
--[[	if bb < 20999 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,bb,20999,42000,math.ceil((20999-bb)/(5*h)).." "..it.l.pirates.."/"..it.l.ventures.."@"..it.l.bb))
	end
	if bb < 42000 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,bb,42000,42000,math.ceil((42000-bb)/(2.5*h)).." "..it.l.pirates.."@"..it.l.gz.."/"..it.l.ra))
	end
]]--
	end

	if (el < 42000) or ((el >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine("  "..it.l.el..":", it.f.status(42000,42000,el))
--[[	if el < 42000 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,el,42000,42000,math.ceil((42000-el)/(2.5*h)).." "..it.l.pirates.."/"..it.l.ventures.."@"..it.l.gz.."/"..it.l.ra.."/"..it.l.bb))
	end
]]--
	end

	if (gz < 42000) or ((gz >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine("  "..it.l.gz..":", it.f.status(42000,42000,gz))
--[[	if gz < 20999 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,gz,20999,42000,math.ceil((20999-gz)/(5*h)).." "..it.l.pirates.."@"..it.l.gz))
	end
	if gz < 42000 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,gz,42000,42000,math.ceil((42000-gz)/(2.5*h)).." "..it.l.pirates.."/"..it.l.ventures.."@"..it.l.ra.."/"..it.l.bb))
	end
]]--
	end

	if (ra < 42000) or ((ra >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		self:AddDoubleLine("  "..it.l.ra..":", it.f.status(42000,42000,ra))
--[[	if ra < 20999 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,ra,20999,42000,math.ceil((20999-ra)/(5*h)).." "..it.l.pirates.."@"..it.l.ra))
	end
	if ra < 42000 then
		self:AddDoubleLine(" ", it.f.statuscolor(0,ra,42000,42000,math.ceil((42000-ra)/(2.5*h)).." "..it.l.pirates.."/"..it.l.ventures.."@"..it.l.gz..it.l.bb))
	end
]]--
	end
	if (math.min(bb, el, gz, ra) < 42000) or ((math.min(bb, el, gz, ra) >= 42000) and (1 == insanitytrackersv.options.showcomplete)) then
		if bb+el+gz+ra ~= session["bb"]+session["el"]+session["gz"]+session["ra"] then
			if insanitytrackersv.options.sessionfaction == 1 then
				self:AddDoubleLine(it.l.session..": ", (bb+el+gz+ra-session["bb"]-session["el"]-session["gz"]-session["ra"])..REPUTATION)
			end
			if insanitytrackersv.options.repperhfaction == 1 then
				self:AddDoubleLine(" ", floor(((bb+el+gz+ra-session["bb"]-session["el"]-session["gz"]-session["ra"])*3600)/(GetTime()-starttime)).." "..REPUTATION.."/h")
			end
			if insanitytrackersv.options.etafaction == 1 and math.min(bb, el, gz, ra) < 42000 then
				self:AddDoubleLine(" ", it.l.togopre..it.f.timeleft((168000-bb-el-gz-ra)/((bb+el+gz+ra-session["bb"]-session["el"]-session["gz"]-session["ra"])/(GetTime()-starttime)))..it.l.togo)
			end
		end
	end
		self:AddLine(" ")

	if realm==crealm and player==cplayer then
		if insanitytrackersv[realm][player]["p"] < 100 then
			if not session then it.f.reset("session")end
			if session then
				if insanitytrackersv[realm][player]["abs"]~=session["abs"] then
					if insanitytrackersv.options.session == 1 then
						self:AddDoubleLine(it.l.session..": "..string.format("%."..insanitytrackersv.options.fpnr.."f%%",insanitytrackersv[realm][player]["p"]-session["p"]).."  "..it.f.timeleft(GetTime()-starttime), (insanitytrackersv[realm][player]["abs"]-session["abs"]).." "..REPUTATION)
					end
					if insanitytrackersv.options.repperh == 1 then
						self:AddDoubleLine(" ", floor(((insanitytrackersv[realm][player]["abs"]-session["abs"])*3600)/(GetTime()-starttime)).." "..REPUTATION.."/h")
					end
					if insanitytrackersv.options.eta == 1 then
						self:AddDoubleLine(" ", it.l.togopre..it.f.timeleft(((303000-126000*insanitytrackersv.options.swasone)-insanitytrackersv[realm][player]["abs"])/((insanitytrackersv[realm][player]["abs"]-session["abs"])/(GetTime()-starttime)))..it.l.togo)
					end
				end
			end
		else
			self:AddLine(it.l.insane)
		end
	end
end

--slashcommands
SLASH_INSANITYTRACKER1, SLASH_INSANITYTRACKER2 = '/it', '/insanitytracker'
function SlashCmdList.INSANITYTRACKER(msg)
	it.f.about()
end